/* hash_serialize.c - stringify and destringify a GLib GHashTable
 * Copyright 2002 by Gaal Yahas <gaal@forum2.org>
 */

#ifndef hash_serialize_h
#define hash_serialize_h

#include <glib.h>

typedef GString* (*SerializeFunc) (gpointer data);

typedef struct {
	SerializeFunc  key_serialize;
	SerializeFunc  val_serialize;
	GString       *accum;
} SerializationData;

GString* lj_hash_freeze(GHashTable* hash, SerializeFunc key_serialize, SerializeFunc val_serialize);
GString* gint_serialize(gint* data);
GString* gchar_serialize(gchar* data);

void lj_hash_thaw(GHashTable* hash, SerializeFunc key_deserialize, SerializeFunc val_deserialize, GString *frozen_hash);
gint* gint_deserialize(GString* data);
gchar* gchar_deserialize(GString* data);

#endif /* hash_serialize_h */
